Create = function(fileName, str)
	local f = CreateFile(fileName)
	local len = string.len(str)
	for i = 1, len do
		f:WriteByte(string.byte(str, i))
	end
	return f.Path
end

CheckFile = function(fileName, str, fullName)
	local len = string.len(str)
	local f = OpenFile(fileName)
	if f.Path ~= fullName then
		ErrorMsgBox("Invalid full file name")
		return
	end
	if f.Size ~= len then
		ErrorMsgBox("Invalid file size")
		return
	end
	for i = 1, len do
		if f:ReadByte() ~= string.byte(str, i) then
			ErrorMsgBox("Invalid file contents at position " .. i)
			return
		end
	end
end

OpenRW = function(fileName, str)
	local f = OpenFileRW(fileName)
	local len = string.len(str)
	for i = 1, len do
		f:WriteByte(string.byte(str, i))
		if f.Pos ~= i then
			ErrorMsgBox("Invalid file position information: " .. f.Pos .. " when " .. i .. " is expected")
			return
		end
	end
end

-- Testing FileSystem

if ExtractDirectory("c:\\Dir1\\Dir2\\file.ext") ~= "c:\\Dir1\\Dir2\\" then
	ErrorMsgBox("ExtractDirectory error")
end

if ExtractDirectory("\\Dir2\\file.ext") ~= "\\Dir2\\" then
	ErrorMsgBox("ExtractDirectory error")
end

if ExtractDirectory("\\Dir2") ~= "\\" then
	ErrorMsgBox("ExtractDirectory error")
end

if ExtractFileName("c:\\Dir1\\Dir2\\file.ext") ~= "file.ext" then
	ErrorMsgBox("ExtractFileName error")
end

if ExtractFileName("\\Dir2") ~= "Dir2" then
	ErrorMsgBox("ExtractFileName error")
end

local fileName = "test.tmp"
local wInOut   = "AABBCC"
local rwIn     = "xyz"
local rwOut    = "xyzBCC"

local fullName = Create(fileName, wInOut)
collectgarbage("collect") -- force file to be closed

CheckFile(fileName, wInOut, fullName)
collectgarbage("collect") -- force file to be closed

OpenRW(fileName, rwIn)
collectgarbage("collect") -- force file to be closed

CheckFile(fileName, rwOut, fullName)
collectgarbage("collect") -- force file to be closed

InfoMsgBox("All done!")
